# -*- coding: utf-8 -*- 
"""
test de chargement de la base pour une exportation dans un fichier au format dansguardian
"""
from os import path as osp
from os import unlink

import autopath

from filtrage.export import *
from filtrage.guesser import train_guesser


KEYWORDS = ['noporn', 'porn']
DATA = osp.join(autopath.HERE, 'data')
TRAIN_DB = osp.join(DATA, 'training')
BAYES_DB = osp.join(DATA,'bayesdb', 'guesser.bay')

def init_database():
    """creation des bases bayesiennes (fichiers en .bay)
    définies par les mots-clef
    """
    train_guesser(keywords=KEYWORDS, filename=BAYES_DB, guess_data=TRAIN_DB,
                  mode='meta')
    assert osp.isfile(BAYES_DB)

def rm_database():
    "suppression des fichiers de bases baysiennes"
    unlink(BAYES_DB)

def test_load_pickle_file(usemeta=False):
    """creation des bases bayesiennes (fichiers en .bay)
    définies par les mots-clef
    """
    init_database()
    assert osp.isfile(BAYES_DB)
    d = load_pickle(BAYES_DB)
    assert d.keys() == KEYWORDS

def test_dansgd_blacklist(filename='test.txt', path='.'):
    """generation du fichier de blacklist"""
    try: unlink(filename)
    except: pass
    add_to_blacklist(filename, 'porn', path=path, dbname=BAYES_DB)
    assert osp.isfile(filename)
    fh = file(filename, 'r')
    assert "< knockers ><1>" in fh.read()
    unlink(filename)

# def test_ordered_blacklist(filename='test.txt', path='.'):
#     """le fichier de blacklist est ordonné suivant la pondération des mot-clef    """
#     try: unlink(filename)
#     except: pass
#     add_to_blacklist(filename, 'porn', path=path, dbname=BAYES_DB, sorted=True)
#     assert osp.isfile(filename)
#     fh = file(filename, 'r')
    
#     output = fh.read()
#     assert "< xxx ><34>\n< pantyhose ><36>" in output
#     unlink(filename)

# def test_dansgd_blacklist_negative(filename='test.txt', path='.'):
#     "affectation d'une note de filtrage négative (les mots-clefs de noporn dans le fichier porn par exemple)"
# #     try: unlink(filename)
# #     except: pass
#     add_to_blacklist(filename, 'noporn', path=path, dbname=BAYES_DB, negative=True)
#     assert osp.isfile(filename)
#     fh = file(filename, 'r')
#     print fh.read()
# #     assert "< knockers ><-1>" in fh.read()
# #     unlink(filename)
